type tMetaReqUpdateId = (source: machine, address: int, storageId: int);
type tMetaResUpdateId = (address: int);
event eMetaReqUpdateId: tMetaReqUpdateId;
event eMetaResUpdateId: tMetaResUpdateId;

type tMetaReqDelete = (source: machine, address: int);
type tMetaResDelete = (address: int);
event eMetaReqDelete: tMetaReqDelete;
event eMetaResDelete: tMetaResDelete;

type tMetaReqExists = (source: machine, address: int);
type tMetaResExists = (address: int, found: bool, storageId: int);
event eMetaReqExists: tMetaReqExists;
event eMetaResExists: tMetaResExists;

machine Metabase
{
    var objects: map[int, int];

    start state Init {
        on eMetaReqUpdateId do (r: tMetaReqUpdateId) {
            if ((r.address in objects)) {
                objects -= (r.address);
            }
            objects += (r.address, r.storageId);
            send r.source, eMetaResUpdateId, (address = r.address,);
        }

        on eMetaReqDelete do (r: tMetaReqDelete) {
            objects -= (r.address);
            send r.source, eMetaResDelete, (address = r.address,);
        }

        on eMetaReqExists do (r: tMetaReqExists) {
            if (r.address in objects) {
                send r.source, eMetaResExists, (address = r.address, found = true, storageId = objects[r.address]);
            } else {
                send r.source, eMetaResExists, (address = r.address, found = false, storageId = 0);
            }
        }
    }
}