// Test single PUT and DELETE.
machine TestWithSingleClient
{
  start state Init {
    entry {
      // single client
      SetupWriteCache(1);
    }
  }
}

// creates a random map from accountId's to account balance of size `numAccounts`
fun CreateRandomObjects(numObjects: int) : set[tObject]
{
  var i: int;
  var objects: set[tObject];
  while(i < numObjects) {
    objects += ((address = i, obj = 0));
    i = i + 1;
  }
  return objects;
}

// setup the client server system with one bank server and `numClients` clients.
fun SetupWriteCache(numClients: int)
{
  var i: int;
  var m: Metabase;
  var b: Blobstor;
  var s: Shard;

  m = new Metabase();
  b = new Blobstor();
  s = new Shard((b = b, m = m));

  // before client starts sending any messages make sure we
  // initialize the monitors or specifications
  announce eSpec_DeleteIsFinal_Init;

  // create the clients
  while(i < numClients) {
    new Client((s = s, pool = CreateRandomObjects(1)));
    i = i + 1;
  }
}